/**********************************************************************/
/*    (c)  Copyright  1990-2023   Inglenet Business Solutions         */
/*                 All Rights Reserved                                */
/*                                                                    */
/*  THIS IS PROPRIETARY SOURCE CODE OF  Inglenet Business Solutions   */
/*                                           www.inglenet.com         */
/**********************************************************************/

/* $Id: tipconfig.h,v 4.58 2022/11/16 22:22:02 rjn Exp $ */

#ifndef _TIPCONFIG_H_
#define _TIPCONFIG_H_

#ifndef CPYRIT 	/*"(c) 1990-2023 Inglenet Business Solutions"*/
#define CPYRIT   "\xa9 1990-2023 Inglenet Business Solutions"
#endif

#ifndef CPYRITX
#define CPYRITX   "(c) 1990-2023 Inglenet Business Solutions"
#endif

#ifndef COMPANY
#define COMPANY "Inglenet Business Solutions"
#endif

#ifndef WWWCOMPANY
#define WWWCOMPANY "www.inglenet.ca"
#endif

#ifdef _POSIX_SOURCE
#define GOS_POSIX_WAS_DEFINED _POSIX_SOURCE
#endif

/* OS capability macros     -   Brief description */
/*  ====================    -   ======================= */
/*	GOS_ARPA_INET_H			-	need arpa/inet.h */
/*	GOS_BSD_COMP			-	use BSD_COMP instead of _BSD_SOURCE */
/*	GOS_BSD_SYS_IOCTL_H		-	need _BSD_SOURCE for sys/ioctl.h */
/*	GOS_DIRENT_H			-	need dirent.h */
/*	GOS_FILIO_H				-	need filio.h */
/*	GOS_GRP_H				-	need grp.h */
/*  GOS_HAS_GETOPT_H        -   include getopt.h */
/*  GOS_HAS_FTELLO          -   System has ftello/fseeko */
/*  GOS_HAS_REGEX_H         -   system has <regex.h> */
/*  GOS_HAS_REGEXP_H        -   system has <regexp.h> */
/*  GOS_HAS_REGEXPXX_H      -   use local <regexpxx.h> */
/*  GOS_HAS_SIGNAL_H        -   include sys/signal.h */
/*  GOS_HAS_SOCKLEN_T       -   use socklen_t */
/*  GOS_SOCKOPT_T           -   data type for setsockopt */
/*  GOS_SOCKLEN_T           -   data type for socket length */
/*  GOS_HAS_STDARG_H        -   include stdarg.h */
/*  GOS_HAS_STDDEF_H        -   include stddef.h */
/*  GOS_HAS_STDLIB_H        -   include stdlib.h */
/*  GOS_HAS_STRING_H        -   include string.h */
/*	GOS_HAS_SUN_UCONTEXT	-	use ucontext.h */
/*	GOS_HAS_SVR4_UCONTEXT	-	use ucontext.h */
/*  GOS_HAS_TYPES_H         -   include sys/types.h */
/*  GOS_HAS_SYS_FILE_H		-	include sys/file.h */
/*  GOS_HAS_SYS_IOCTL_H		-	include sys/ioctl.h */
/*  GOS_HAS_ULIMIT_H        -   system has <ulimit.h> */
/*  GOS_HAS_UTSNAME_H       -   include sys/utsname.h */
/*	GOS_HAVE_EINPROGRESS	-	non-blocking I/O uses EINPROGRESS */
/*	GOS_HAVE_FASYNC			-	use fcntl & FASYNC to set ASYNC fd */
/*	GOS_HAVE_FNONBLOCK		-	have FNONBLOCK definition */
/*	GOS_HAVE_O_ASYNC		-	use fcntl_flags & O_ASYNC to set ASYNC fd */
/*	GOS_HAVE_O_NONBLOCK		-	use fcntl_flags O_NONBLOCK definition */
/*	GOS_HAVE_SIGACTION		-	sigaction() exists */
/*	GOS_HAVE_SIGHOLD		-	sighold() and sigrelse() will be used */
/*	GOS_HAVE_SIGIO			-	use SIGIO signal */
/*	GOS_HAVE_SIGJMP_BUF		-	use sigjmp_buf type */
/*	GOS_HAVE_STRDUP			-	strdup() already exists */
/*	GOS_LIBIO_H				-	need libio.h */
/*	GOS_NO_FNDELAY			-	don't have FNDELAY definition */
/*	GOS_POSIX_C_SIGNAL_H	-	need _POSIX_C_SOURCE for signal.h */
/*	GOS_POSIX_EXT_SIGNAL_H	-	need _EXTENTIONS_ for signal.h */
/*	GOS_POSIX_SETJMP_H		-	need _POSIX_SOURCE for setjmp.h */
/*	GOS_POSIX_SIGNAL_H		-	need _POSIX_SOURCE for signal.h */
/*	GOS_POSIX_TIMES_H		-	need _POSIX_SOURCE for times.h */
/*	GOS_POSIX_WAIT_H		-	need _POSIX_SOURCE for sys/wait.h */
/*	GOS_PWD_H				-	need pwd.h */
/*	GOS_SYS_SOCKET_H		-	use sys/socket.h */
/*	GOS_NETINET_IN_H		-	use netinet/in.h */
/*	GOS_NETDB_H				-	use netdb.h */
/*	GOS_SYS_TIMES_H			-	use sys/times.h */
/*	GOS_SYS_WAIT_H			-	use sys/wait.h */
/*	GOS_STANDARDS_H			-	need standards.h */
/*	GOS_STROPTS_H			-	need stropts.h */
/*	GOS_SYSV_BSD_UNDEFS		-	special undefs for BSD/SYSV mish-mash */
/*	GOS_TERMIO_H			-	need termio.h */
/*	GOS_TERMIOS_H			-	Use termios.h instead of termio.h */
/*	GOS_TTY_FIOSETOWN		-	use FIOSETOWN & FIOASYNC for ASYNC tty's */
/*	GOS_TTY_FIOSSAIOOWN		-	use ioctl  FIOSSAIOOWN & I_SETSIG for ASYNC tty's */
/*	GOS_TTY_F_SETOWN		-	use ioctl F_SETOWN & F_SETFL for ASYNC tty's */
/*	GOS_TTY_I_SETSIG		-	use ioctl & I_SETSIG for ASYNC tty's */
/*	GOS_UNDEF_FIVE_SIGNAL_H	-	undef SYSTEM_FIVE for signal.h (DEC) */
/*	GOS_UNISTD_H			-	need unistd.h */
/*	GOS_USE_EWOULDBLOCK		-	uses EWOULDBLOCK instead of EAGAIN */
/*  GOS_USE_FIONREAD        -   use ioctl FIONREAD */
/*	GOS_USE_I_SETSIG		-	use ioctl & I_SETSIG for all ASYNC fd's */
/*  GOS_USE_TIOCINQ         -   use ioctl TIOCINQ instead of FIONREAD */

/*  CONSTUNSETENV           -   'unsetenv' has 'const' parameter */
/*  dB07                    -   C compiler assigns 'Bit' from 0 thru 7 */
/*  dB70                    -   C compiler assigns 'Bit' from 7 thru 0 */
/*  dBigEnd                 -   Integers stored in Big Endian (like IBM) */
/*  dBit64                  -   System is 64 bit mode, else assume 32 bit */
/*  dBitDual                -   System may be either 32 or 64 bit mode */
/*  dBSD                    -   System is more like BSD (Berkly Unix) */
/*  dHasOpenSSL             -   System has OpenSSL installed */
/*  dHaveLongLong           -   System supports 'long long' data type */
/*  DISAM7                  -   D-ISAM version 7 is being used */
/*  dLittleEnd              -   Integers stored in Little Endian (like 386) */
/*  DLLAPIDECL              -   Defined value needed for DLL entry on Windows */
/*  dMmapAvail              -   System has a working 'mmap' else only Shared memory */
/*  dNbpb                   -   Number of bits per byte (Almost always 8) */
/*  dSysV		            -   Unix System V ... most others */
/*  dTipixTarget            -   String with system type (AIXPPC, LINUX, etc) */
/*  dVBISAM                 -   Systems supports VB-ISAM */
/*  INTUNSETENV             -   'unsetenv' returns 'int' type */
/*  USE_POLL                -   use 'poll' instead of 'select' */
/*  VOIDUNSETENV            -   'unsetenv' returns 'void' type */
/*  WINDOWS                 -   Module is being compiled in Windows system */


/*  Default following as TRUE */
#if !defined(SCO)
#define dMmapAvail
#endif
#define GOS_HAS_GETOPT_H
#define GOS_HAS_REGEXP_H
#define GOS_HAS_SIGNAL_H
#define GOS_HAS_STDARG_H
#define GOS_HAS_STDLIB_H
#define GOS_HAS_STRING_H
#define GOS_HAS_TYPES_H
#define GOS_HAS_SYS_FILE_H
#define GOS_HAS_SYS_IOCTL_H
#define GOS_HAS_ULIMIT_H
#define USE_POLL
#define GOS_HAS_FTELLO
#define GOS_SYS_SOCKET_H
#define GOS_NETINET_IN_H
#define GOS_NETDB_H
#define GOS_SYS_TIMES_H
#define GOS_SYS_WAIT_H
#if defined(SVR4)
#define GOS_HAS_SVR4_UCONTEXT
#endif
/* set dHaveLongLong by default... undef where appropriate */
#define dHaveLongLong

/* ************************************************************* */
/*	System hardware features - Default to typical RISC machine   */
/* ************************************************************* */
#undef	dBSD		/* Berkey Unix base ... ie. SunOs 4.1.1 */
#define	dSysV		/* Unix System V ... most others */
#define dSysV3
#undef	dB07 		/* C compiler assigns 'Bit' from 0 thru 7 */
#define	dB70 		/* C compiler assigns 'Bit' from 7 thru 0 */
#undef	dLittleEnd
#define	dBigEnd
#define	dNbpb	8	/* 8 bits per byte */
#ifdef dSysV4
#undef dSysV3
#endif

#if defined(ZLINUX) || defined(__s390__) || defined(__s390x__)
/* Linux on IBM Z Series hardware */
#if defined(GOS_HAS_SVR4_UCONTEXT)
#undef GOS_HAS_SVR4_UCONTEXT
#endif
#undef GOS_HAS_REGEXP_H
#define GOS_HAS_SOCKLEN_T
#define	GOS_ARPA_INET_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_SIGACTION
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_SETJMP_H
#define	GOS_POSIX_SIGNAL_H
#define	GOS_POSIX_TIMES_H
#define	GOS_SYSV_BSD_UNDEFS
#define	GOS_UNISTD_H
#define	GOS_TTY_FIOSETOWN
#define	GOS_HAVE_FNONBLOCK
#define	GOS_LIBIO_H
#define	GOS_TERMIO_H
#undef  USE_POLL
#define	GOS_STROPTS_H
#define	dHasOpenSSL 1
#if defined(USE_LARGEFILE) && !defined(__s390x__)
#define __USE_LARGEFILE64
#define __USE_FILE_OFFSET64
#endif
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#if defined(ZLINUX)
#define dTipixTarget "ZLINUX"
#else
#define dTipixTarget "LINUX390"
#endif
#ifdef dLittleEnd
#undef	dLittleEnd
#endif
#ifndef dBigEnd
#define	dBigEnd
#endif
#if defined(__s390x__) && !defined(dBit64)
#define dBit64
#endif

#elif defined(__linux__) || defined(LINUX) || (REDHAT >= 6) || defined(CENTOS) || defined(REDHAT6) || defined(REDHAT67) || defined(REDHAT68) || defined(REDHAT7) || defined(CENTOS7) || defined(CENTOS8)
#define HAS_ODBC 1
#if (REDHAT >= 8) || defined(CENTOS8)
#if defined(REDHAT)
#undef REDHAT
#endif
#define REDHAT 8
#elif (REDHAT >= 7) || defined(CENTOS7)
#if defined(REDHAT)
#undef REDHAT
#endif
#define REDHAT 7
#elif defined(REDHAT6)
#if defined(REDHAT)
#undef REDHAT
#endif
#define REDHAT 6
#endif
#if defined(GOS_HAS_SVR4_UCONTEXT)
#undef GOS_HAS_SVR4_UCONTEXT
#endif
#define GOS_HAS_SOCKLEN_T
#define	GOS_ARPA_INET_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_SIGACTION
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_SETJMP_H
#define	GOS_POSIX_SIGNAL_H
#define	GOS_POSIX_TIMES_H
#define	GOS_SYSV_BSD_UNDEFS
#define	GOS_UNISTD_H
#define	GOS_TTY_FIOSETOWN
#define GOS_TTY_F_SETOWN
#define	GOS_HAVE_FNONBLOCK
#if (REDHAT < 8)
#define	GOS_LIBIO_H
#endif
#define	GOS_TERMIO_H
#if defined(USE_LARGEFILE) && !defined(__x86_64__)
#define __USE_LARGEFILE64
#define __USE_FILE_OFFSET64
#endif
#if (REDHAT < 5)
#undef  USE_POLL
#endif
#if (REDHAT < 6)
#define	GOS_STROPTS_H
#endif
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#if defined(CENTOS) || defined(CENTOS7) || defined(CENTOS8)
#if defined(REDHAT) && (REDHAT >=6)
#if defined(REDHAT8) || (REDHAT >= 8)
#define dTipixTarget "CENTOS8"
#undef GOS_HAS_REGEXP_H
#define GOS_USE_FIONREAD
#elif defined(REDHAT7) || (REDHAT >= 7)
#define dTipixTarget "CENTOS7"
#elif defined(REDHAT68)
#define dTipixTarget "CENTOS68"
#elif defined(REDHAT67)
#define dTipixTarget "CENTOS67"
#else
#define dTipixTarget "CENTOS6"
#endif
#define GOS_USE_FIONREAD
#else
#define dTipixTarget "CENTOS"
#endif
#elif defined(REDHAT)
#if defined(REDHAT) && (REDHAT >=8)
#define dTipixTarget "REDHAT8"
#undef GOS_HAS_REGEXP_H
#define GOS_USE_FIONREAD
#elif defined(REDHAT) && (REDHAT >=7)
#define dTipixTarget "REDHAT7"
#elif defined(REDHAT) && (REDHAT >=6)
#define dTipixTarget "REDHAT6"
#else
#define dTipixTarget "REDHAT"
#endif
#else
#define dTipixTarget "LINUX"
#endif
#if defined(REDHAT) && (REDHAT >= 5)
#define	dHasOpenSSL 1
#endif
#define CONSTUNSETENV 1

#elif defined(CYGWIN) || defined(__CYGWIN__)
/* Cygwin on Windows */
#undef  GOS_HAS_REGEXP_H
#undef  GOS_HAS_ULIMIT_H
#undef  dMmapAvail
#define GOS_HAS_NCURSES_H
#define GOS_HAS_REGEX_H
#define	GOS_ARPA_INET_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_SETJMP_H
#define	GOS_POSIX_SIGNAL_H
#define	GOS_POSIX_TIMES_H
#define	GOS_SYSV_BSD_UNDEFS
#define	GOS_UNISTD_H
#define	GOS_HAVE_FNONBLOCK
#define	GOS_HAVE_FASYNC
#define GOS_USE_TTY_FASYNC
#define	GOS_TERMIOS_H
#define GOS_USE_TIOCINQ
#if !defined(INTUNSETENV)
#define INTUNSETENV 1
#endif
#define CONSTUNSETENV 1
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "CYGWIN"
#if !defined(DLLAPI) && defined(API) && defined(DLL)
#define DLLAPI 1
#endif
#if defined(DLLAPI)
/* Need for use as a DLL under Windows SUA */
#define _IMPORT_LIBCDLL_GLOBALS 1
#define _CTYPE_DISABLE_MACROS 1
#define DLLAPIDECL __declspec(dllexport)
#elif defined(_REENTRANT)
#define _IMPORT_LIBCDLL_GLOBALS 1
#define _CTYPE_DISABLE_MACROS 1
#endif

#elif defined(SFU)
/* Windows Services for Unix */
#define	GOS_ARPA_INET_H
#define GOS_HAS_REGEXPXX_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_SETJMP_H
#define	GOS_POSIX_SIGNAL_H
#define	GOS_POSIX_TIMES_H
#define	GOS_SYSV_BSD_UNDEFS
#define	GOS_UNISTD_H
#define	GOS_TTY_FIOSETOWN
#define	GOS_HAVE_FNONBLOCK
#define GOS_HAVE_O_ASYNC
#define GOS_HAVE_O_NONBLOCK	
#define GOS_TTY_F_SETOWN
#define	GOS_TERMIOS_H

#elif defined(UW7) || defined(UW8) || defined(UW713)
#undef  GOS_HAS_GETOPT_H
#undef	GOS_HAS_FTELLO 
#define GOS_HAS_STDDEF_H
#define	GOS_ARPA_INET_H
#define	GOS_BSD_COMP
#define	GOS_BSD_SYS_IOCTL_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_FNONBLOCK
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_SETJMP_H
#define	GOS_POSIX_SIGNAL_H
#define	GOS_POSIX_TIMES_H
#define	GOS_STROPTS_H
#define	GOS_SYSV_BSD_UNDEFS
#define	GOS_TTY_I_SETSIG
#define	GOS_USE_I_SETSIG
#define	GOS_UNISTD_H
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "UW7"
#if defined(UW8) || defined(UW713)
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "UW713"
#endif
#endif

#if defined(MACOS)
#if defined(GOS_HAS_SVR4_UCONTEXT)
#undef GOS_HAS_SVR4_UCONTEXT
#endif
#undef GOS_HAS_REGEXP_H
#define GOS_HAS_REGEX_H
#define GOS_HAS_SOCKLEN_T
#define	GOS_ARPA_INET_H
#define	GOS_BSD_COMP
#define	GOS_BSD_SYS_IOCTL_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_FNONBLOCK
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_SETJMP_H
#define	GOS_POSIX_SIGNAL_H
#define	GOS_POSIX_TIMES_H
#define	GOS_SYSV_BSD_UNDEFS
#define	GOS_TTY_FIOSETOWN
#undef	GOS_TTY_I_SETSIG
#undef	GOS_USE_I_SETSIG
#define	GOS_UNISTD_H
#define	GOS_TERMIOS_H
#define GOS_USE_FIONREAD
#undef	GOS_STROPTS_H
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "MACOS"
#if !defined(dBit64)
#define dBit64
#endif
#if 0
/* Needs some special compile/link procedure; so defer this for now; RJN */
#define	dHasOpenSSL 1
#endif
#if !defined(INTUNSETENV)
#define INTUNSETENV 1
#endif
#define CONSTUNSETENV 1
#endif

#ifdef sparc	/* "sparc" SunOs differences */
#if !defined(dTipixTarget)
#define dTipixTarget "SUN"
#endif
#define HAS_ODBC 1
#undef  dSysV3
#define dSysV4
#undef	dSysV
/* #define	dBSD */
#undef	dB07
#define	dB70
#ifdef dLittleEnd
#undef	dLittleEnd
#endif
#ifndef dBigEnd
#define	dBigEnd
#endif
#if defined(_LP64) && !defined(dBit64)
#define dBit64
#endif
#endif

#if defined(u370) || defined(_S370)	/* "u370" System V */
#ifndef dSysV
#define dSysV
#endif
#undef 	dBSD
#undef	dB07
#define	dB70
#ifdef dLittleEnd
#undef	dLittleEnd
#endif
#ifndef dBigEnd
#define	dBigEnd
#endif
#define dSysV3
#endif

/* *********** "Intel" Unix V ******************* */
#if defined(__x86_64__) || defined(__i386__) || defined(i386)
#define	dSysV
#undef	dBSD
#define	dB07
#undef	dB70
#ifndef dLittleEnd
#define	dLittleEnd
#endif
#ifdef dBigEnd
#undef	dBigEnd
#endif
#if defined(__x86_64__)
#define dBit64
#elif defined(dBit64)
#undef dBit64
#endif
#endif

#if defined(SUN)
#undef  GOS_HAS_GETOPT_H
#define GOS_HAS_SUN_UCONTEXT
#define GOS_HAS_STDDEF_H
#define	GOS_ARPA_INET_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_FASYNCx
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_SETJMP_H
#define	GOS_POSIX_SIGNAL_H
#define	GOS_POSIX_C_SIGNAL_H
#define	GOS_POSIX_TIMES_H
#define	GOS_STROPTS_H
#define	GOS_TTY_I_SETSIG
#define	GOS_USE_I_SETSIG
#define	GOS_UNISTD_H
#define	GOS_FILIO_H
/* __EXTENSIONS__ need for some of the sys/headers.h on Solaris */
#define __EXTENSIONS__
#if defined(_LP64) && !defined(dBit64)
#define dBit64
#endif
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "SUN"
#endif /* SUN */

#if defined(ibm) || defined(AIXPPC)
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "AIXPPC"
#ifdef USELFS
#ifndef _LARGE_FILES
#define _LARGE_FILES
#endif
#endif
#ifdef __64BIT__
#define dBit64
#endif
#undef  GOS_HAS_GETOPT_H
#define	GOS_ARPA_INET_H
#define GOS_HAS_SOCKLEN_T
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_FNONBLOCK
#define	GOS_HAVE_SIGHOLD
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_TIMES_H
#define	GOS_POSIX_WAIT_H
#define	GOS_STANDARDS_H
#define	GOS_TTY_FIOSETOWN
#define	GOS_UNISTD_H
#define	GOS_TERMIOS_H
#define GOS_USE_FIONREAD
#define	GOS_DIRENT_H
#define	GOS_PWD_H
#define	GOS_GRP_H
#define	GOS_HAS_UTSNAME_H
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE
#endif
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "AIXPPC"
#endif /* ibm */

#if defined(hpux) || defined(HPUX)
#undef  GOS_HAS_GETOPT_H
#undef  dMmapAvail
#define	GOS_ARPA_INET_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_TIMES_H
#define	GOS_UNISTD_H
#define	GOS_STROPTS_H
#define	GOS_TTY_I_SETSIG
#define GOS_TTY_FIOSSAIOOWN
#ifdef _XOPEN_SOURCE_EXTENDED
#define GOS_HAS_SOCKLEN_T
#endif
#if defined(USE_LARGEFILE) && !defined(__LP64__)
#define _LARGEFILE64_SOURCE
#endif

#if defined(__LP64__)
#define	GOS_TERMIOS_H
#endif
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "HPUX"
#undef	dBSD
#define	dSysV
#undef	dB07
#define	dB70
#undef	dLittleEnd
#define	dBigEnd
#define dSysV3
#if defined(__LP64__)
#define dBit64
#define dHPUXCurses 1
#endif
#endif /* hpux */

#if defined(hpit) || defined(HPIT) || defined(HPUX_IA64)
#undef  USE_POLL
#undef  GOS_HAS_GETOPT_H
#undef  dMmapAvail
#define	GOS_ARPA_INET_H
#define	GOS_HAVE_EINPROGRESS
#define	GOS_HAVE_SIGIO
#define	GOS_HAVE_SIGJMP_BUF
#define	GOS_HAVE_STRDUP
#define	GOS_POSIX_TIMES_H
#define	GOS_UNISTD_H
#define	GOS_STROPTS_H
#define	GOS_TTY_I_SETSIG
#define GOS_TTY_FIOSSAIOOWN
#define	GOS_TERMIO_H
#define	GOS_TERMIOS_H
#ifdef _XOPEN_SOURCE_EXTENDED
#define GOS_HAS_SOCKLEN_T
#endif
/*  Check for HPUX Itanium system */
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "HPIT"
#define dHPUXCurses 1
#ifndef dHasOpenSSL
#define	dHasOpenSSL 1
#endif
#ifdef dHasOpenSSL
/* Problems linking on HPUX Itanium so do nto use this here */
#undef	dHasOpenSSL
#endif
#if defined(USE_LARGEFILE) && !defined(HPUX_IA64)
#define _LARGEFILE64_SOURCE
#endif
#if defined(HPUX_IA64)
#define dBit64
#endif
#undef	dBSD
#ifndef unix
#define unix 1
#endif
#ifndef dSysV
#define dSysV
#endif
#ifdef dSysV3
#undef dSysV3
#endif
#ifndef dSysV4
#define dSysV4
#endif
#ifdef dB07
#undef	dB07
#endif
#ifndef dB70
#define	dB70
#endif
#ifdef dLittleEnd
#undef	dLittleEnd
#endif
#ifndef dBigEnd
#define	dBigEnd
#endif
#endif /* hpit */

#if defined(WINDOWS)
#undef GOS_HAS_SYS_FILE_H
#undef GOS_HAS_SYS_IOCTL_H
#undef GOS_HAS_GETOPT_H
#undef GOS_SYS_SOCKET_H
#undef GOS_NETINET_IN_H
#undef GOS_NETDB_H
#undef GOS_SYS_TIMES_H
#undef GOS_SYS_WAIT_H
#endif

#if defined(GOS_DIRENT_H)
#include <dirent.h>
#endif

#if defined(GOS_HAS_TYPES_H)
#include <sys/types.h>
#endif

#if defined(GOS_HAS_UTSNAME_H)
#include <sys/utsname.h>
#endif

#ifdef GOS_STANDARDS_H
#include <standards.h>
#endif

#include <stdio.h>
#include <limits.h>

#if defined(GOS_PWD_H)
#include <pwd.h>
#endif

#if defined(GOS_GRP_H)
#include <grp.h>
#endif

#if defined(GOS_HAS_STRING_H)
#include <string.h>
#endif

#if defined(GOS_HAS_STDLIB_H)
#include <stdlib.h>
#endif

#if defined(GOS_HAS_STDARG_H)
#include <stdarg.h>
#endif

#if defined(GOS_HAS_STDDEF_H)
#include <stddef.h>
#endif

#include <fcntl.h>
#if defined(GOS_HAS_SYS_FILE_H)
#include <sys/file.h>
#endif
#include <errno.h>

#ifdef GOS_UNISTD_H
#include <unistd.h>
#endif /* GOS_UNISTD_H */

#if defined(GOS_HAS_GETOPT_H)
#include <getopt.h>
#else
extern int optind, opterr, optopt;
extern char *optarg;
#endif
#if defined(LINUX)
#define RESETOPTIND optind = 0;
#else
#define RESETOPTIND optind = 1;
#endif

#ifdef GOS_STROPTS_H
#include <stropts.h>
#endif /* GOS_STROPTS_H */

#ifdef GOS_LIBIO_H
#include <libio.h>
#if !defined(S_INPUT)
#define S_INPUT _IOS_INPUT
#define S_OUTPUT _IOS_OUTPUT
#endif
#endif /* GOS_LIBIO_H */

#ifdef GOS_SYS_SOCKET_H
#include <sys/socket.h>
#endif
#ifdef GOS_NETINET_IN_H
#include <netinet/in.h>
#endif
#ifdef GOS_NETDB_H
#include <netdb.h>
#endif

#ifdef GOS_POSIX_SETJMP_H
#ifdef _POSIX_SOURCE
#undef _POSIX_SOURCE
#endif
#define	_POSIX_SOURCE
#endif /* GOS_POSIX_SETJMP_H */

#include <setjmp.h>

#ifdef GOS_POSIX_SETJMP_H
#undef	_POSIX_SOURCE
#ifdef GOS_POSIX_WAS_DEFINED
#define _POSIX_SOURCE GOS_POSIX_WAS_DEFINED
#endif
#endif /* GOS_POSIX_SETJMP_H */

#ifdef GOS_BSD_SYS_IOCTL_H
#ifdef GOS_BSD_COMP
#define	BSD_COMP
#  else /* GOS_BSD_COMP */
#define	_BSD_SOURCE
#endif /* GOS_BSD_COMP */
#endif /* GOS_BSD_SYS_IOCTL_H */

/* Following defines are for TIP/ix on UNIX System V */
#if !defined(DOS) && !defined(WINDOWS)
#ifndef UNIX
#define UNIX
#endif
#ifndef unix
#define unix
#endif
#ifndef TIPIX
#define TIPIX
#endif
#if !defined(dTipixTarget)
#define dTipixTarget "UNIX"
#endif
#endif

/* Treat Characters as "un-signed" */
typedef unsigned char   Char;
typedef unsigned char   Uchar;
typedef unsigned char * Pchar;

/* Treat Un-packed numeric as Unsigned characters */
typedef unsigned char   Numeric;

/* Treat packed numeric as Unsigned characters */
typedef unsigned char   PackDec;

/* Various integers */
typedef char            Bool;
typedef short           Short;
typedef unsigned short  Ushort;

#ifdef NO_ANSI_HASH_OPS
#define cppSTRING(val)		"val"
#define cppPASTE(fore,aft)	fore/**/aft
#else
#define cppSTRING(val)		#val
#define cppPASTE(fore,aft)	fore##aft
#endif

#if defined(dBit64)
typedef int         		Int;
typedef unsigned int 		Uint;
typedef int         		Long;
/* Offset used inside of TIP/ix of less than 4 GIG are more than enough */
typedef unsigned int		Offset;
typedef long				LongLong;
typedef unsigned long		ULongLong;
typedef unsigned long		Uintptr;
#define LL(n)	cppPASTE(n,L)

#else
typedef long int          	Int;
typedef long int          	Long;
typedef unsigned long int 	Uint;
typedef unsigned long int  	Offset;	
typedef unsigned long		Uintptr;
#if defined(dHaveLongLong)
typedef long long		  	LongLong;
typedef unsigned long long	ULongLong;
#endif
#define LL(n)	cppPASTE(n,LL)

#endif

/* need to include this now to avoid (some) redefinitions */
#include <gosculib.h>

/* then these undef's avoid a bunch more SYSV/BSD termios.h/ioctl.h conflicts */
#ifdef GOS_SYSV_BSD_UNDEFS
#if !defined(GOS_KEEP_ECHO)
#undef ECHO
#endif
#undef NL0
#undef NL1
#undef TAB0
#undef TAB1
#undef TAB2
#undef XTABS
#undef CR0
#undef CR1
#undef CR2
#undef CR3
#undef FF0
#undef FF1
#undef BS0
#undef BS1
#undef TOSTOP
#undef FLUSHO
#undef PENDIN
#undef NOFLSH
#undef CTRL
#endif /* GOS_SYSV_BSD_UNDEFS */

#if defined(GOS_HAS_SYS_IOCTL_H)
#include <sys/ioctl.h>
#endif

#if defined(GOS_TERMIOS_H)
#include <termios.h>
#endif

#if defined(GOS_TERMIO_H)
#include <termio.h>
#endif

#ifdef GOS_FILIO_H
#include <sys/filio.h>
#include <sys/sockio.h>
#endif

#ifdef GOS_BSD_SYS_IOCTL_H
#ifdef GOS_BSD_COMP
#undef	BSD_COMP
#  else /* GOS_BSD_COMP */
#undef	_BSD_SOURCE
#endif /* GOS_BSD_COMP */
#endif /* GOS_BSD_SYS_IOCTL_H */

#ifdef GOS_ARPA_INET_H
#include <arpa/inet.h>
#endif /* GOS_ARPA_INET_H */

#ifdef GOS_HAVE_EINPROGRESS
#define	GOS_EINPROGRESS	EINPROGRESS
# else /* GOS_HAVE_EINPROGRESS */
#define	GOS_EINPROGRESS	EAGAIN
#endif /* GOS_HAVE_EINPROGRESS */

#ifdef GOS_USE_EWOULDBLOCK
#define	GOS_EAGAIN	EWOULDBLOCK
# else
#define	GOS_EAGAIN	EAGAIN
#endif

#if defined(__linux__) || defined(__CYGWIN__)
#define	GOS_FNONBLOCK	O_NONBLOCK
#define	GOS_FNDELAY		O_NDELAY
#else
#ifdef GOS_HAVE_FNONBLOCK
#define	GOS_FNONBLOCK	FNONBLOCK
# else /* GOS_HAVE_FNONBLOCK */
#define	GOS_FNONBLOCK	FNDELAY
#endif /* GOS_HAVE_FNONBLOCK */

#ifdef GOS_NO_FNDELAY
#define	GOS_FNDELAY FNONBLOCK
# else /* GOS_NO_FNDELAY */
#define	GOS_FNDELAY	FNDELAY
#endif /* GOS_NO_FNDELAY */
#endif

#ifdef GOS_POSIX_SIGNAL_H
#ifdef _POSIX_SOURCE
#undef _POSIX_SOURCE
#endif
#define _POSIX_SOURCE
#endif
#ifdef GOS_STDC
#ifdef _STDC_
#undef _STDC_
#endif
#define _STDC_ 0
#endif
#ifdef GOS_POSIX_C_SIGNAL_H
#define _POSIX_C_SOURCE	199309L
#endif
#ifdef GOS_POSIX_EXT_SIGNAL_H
#define __EXTENTIONS__
#endif

#ifdef GOS_UNDEF_FIVE_SIGNAL_H
#undef	__SYSTEM_FIVE
#endif

#if defined(GOS_HAS_SIGNAL_H)
#include <signal.h>
#if defined(SIGCLD) && !defined(SIGCHLD)
#define SIGCHLD SIGCLD
#elif defined(SIGCHLD) && !defined(SIGCLD)
#define SIGCLD SIGCHLD
#endif
#endif

#ifdef GOS_UNDEF_FIVE_SIGNAL_H
#define	__SYSTEM_FIVE	SYSTEM_FIVE
#endif

#ifdef GOS_POSIX_SIGNAL_H
#undef _POSIX_SOURCE
#ifdef GOS_POSIX_WAS_DEFINED
#define _POSIX_SOURCE GOS_POSIX_WAS_DEFINED
#endif
#endif
#ifdef GOS_POSIX_C_SIGNAL_H
#undef _POSIX_C_SOURCE
#endif
#ifdef GOS_POSIX_EXT_SIGNAL_H
#undef __EXTENTIONS__
#endif

#ifdef GOS_POSIX_TIMES_H
#ifdef _POSIX_SOURCE
#undef _POSIX_SOURCE
#endif
#define _POSIX_SOURCE
#endif  /* GOS_POSIX_TIMES_H */

#ifdef GOS_SYS_TIMES_H
#include <sys/times.h>
#endif

#ifdef GOS_POSIX_TIMES_H
#undef _POSIX_SOURCE
#ifdef GOS_POSIX_WAS_DEFINED
#define _POSIX_SOURCE GOS_POSIX_WAS_DEFINED
#endif
#endif  /* GOS_POSIX_TIMES_H */

#ifdef GOS_POSIX_WAIT_H
#ifdef _POSIX_SOURCE
#undef _POSIX_SOURCE
#endif
#define _POSIX_SOURCE
#endif  /* GOS_POSIX_WAIT_H */

#ifdef GOS_SYS_WAIT_H
#include <sys/wait.h>
#endif

#ifdef GOS_POSIX_WAIT_H
#undef _POSIX_SOURCE
#ifdef GOS_POSIX_WAS_DEFINED
#define _POSIX_SOURCE GOS_POSIX_WAS_DEFINED
#endif
#endif  /* GOS_POSIX_WAIT_H */

/* need to define sigjmp_buf type for some OS */
#ifndef GOS_HAVE_SIGJMP_BUF
#if defined(_SIGJBLEN)
typedef int sigjmp_buf[_SIGJBLEN];
#endif
#endif

/* if the OS has sighold() and sigrelse() use simple macros */
#ifdef GOS_HAVE_SIGHOLD
#define	gosSigHold(sig)		sighold(sig)
#define	gosSigRelse(sig)	sigrelse(sig)
#endif /* GOS_HAVE_SIGHOLD */

/* some OS don't define SIGIO */
#ifndef GOS_HAVE_SIGIO
#ifndef SIGIO
#define	SIGIO	SIGPOLL
#endif
#endif /* GOS_HAVE_SIGIO */

#ifdef CTRL
#undef CTRL
#endif
#define	CTRL(c)		(c & 0x1f)



/* ************************************************************* */
/* ************************************************************* */
/* ************************************************************* */


#if	defined(SFU)	/* Windows Services For Unix */
#undef GOS_HAS_REGEXP_H
#undef  dMmapAvail
#ifdef dTipixTarget
#undef dTipixTarget
#endif
#define dTipixTarget "SFU"
#ifndef unix
#define unix 1
#endif
#undef	dBSD
#define	dB07
#undef	dB70
#ifndef dLittleEnd
#define	dLittleEnd
#endif
#ifdef dBigEnd
#undef	dBigEnd
#endif
#include <limits.h>
#if !defined(DLLAPI)
#if defined(API) && defined(DLL)
#define DLLAPI 1
#endif
#endif
#if defined(DLLAPI)
/* Need for use as a DLL under Windows SUA */
#define _IMPORT_LIBCDLL_GLOBALS 1
#define _CTYPE_DISABLE_MACROS 1
#define DLLAPIDECL __declspec(dllexport)
#elif defined(_REENTRANT) 
#define _IMPORT_LIBCDLL_GLOBALS 1
#define _CTYPE_DISABLE_MACROS 1
#endif
#include <ctype.h>
#endif


#if defined(WINDOWS) || defined(WIN32)  /* For MS WINDOWS */
#undef	dB70		/* Microsoft C compiler bit assignments */
#define dB07
#undef dBigEnd
#define	dLittleEnd
#ifdef UNIX
#undef UNIX
#endif
#ifdef TIPIX
#undef TIPIX
#endif
#ifdef dSysV4
#undef dSysV4
#endif

#else
#define DLLEXPORT
#define DLLIMPORT
#endif


/* 
	Choose one of the following   Data management systems 
*/
#ifdef DISAM7
#undef DISAM7
#endif
#define DISAM7	/* Using Byte Designs D-ISAM 7 data management */
/* #define CISAM */
#if defined(LINUX) || defined(HPIT) || defined(AIXPPC) || defined(SUN)
#undef dVBISAM
#define dVBISAM 1
#endif

#if defined(DOS) || defined(WINDOWS)
#ifndef TIPPC
#define TIPPC
#endif
#endif

/* The TIP API modules will be using DLLAPIDECL where needed */
#if !defined(DLLAPIDECL)
#define DLLAPIDECL 
#endif

#if defined(USELFS)
#if defined(AIXPPC)
#if !defined(_LARGE_FILES)
#define _LARGE_FILES
#endif
#endif
#endif

/*  Following are used as variables in some programs */
#ifdef lines
#define ORG_lines lines
#undef lines
#endif
#ifdef bell
#define ORG_bell bell
#undef bell
#endif
#ifdef colmuns
#define ORG_columns columns
#undef colmuns
#endif
#ifdef form_feed
#undef form_feed
#endif
#ifdef newline
#define ORG_newline columns
#undef newline
#endif
#if defined(tab)
#define ORG_tab tab
#undef tab
#endif
#if defined(cols)
#define ORG_cols cols
#undef cols
#endif
#if !defined(GOS_SOCKOPT_T)	/* Most of the time this is an 'int' */
#define GOS_SOCKOPT_T int
#endif

#endif /* _TIPCONFIG_H_ */
